﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using PSModuleSample;
using System.Diagnostics;

namespace SampleGUIApplication
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            colContainer.Collection
                = new[] { ComputerStatus.Good, ComputerStatus.Warning, ComputerStatus.Error };
            _history = new InvokeHistory();
        }

        private InvokeHistory _history;

        private void btnGet_Click(object sender, RoutedEventArgs e)
        {
            var parameters=new Dictionary<string, object>() ;
            if (txtComputer.Text == "")
            {
                if(cmbStatus.SelectedValue is ComputerStatus)
                {
                    parameters.Add("Status", cmbStatus.SelectedValue);
                }
            }
            else 
            {
                if (cmbStatus.SelectedValue is ComputerStatus)
                {
                    MessageBox.Show("取得条件はどちらか一方にしてください。");
                    return;
                }
                else
                {
                    parameters.Add("Name", txtComputer.Text);
                }
            }

            var command = new CommandInvoker("Get-Status", parameters);
            DataContext = command.Execute<Server>();
            _history.Write(command);
        }

        private void btnUpdate_Click(object sender, RoutedEventArgs e)
        {
            var parameters = new Dictionary<string, object>();
            if (txtComputer.Text == "")
            {
                MessageBox.Show("コンピュータ名を入れてください。");
                return;
            }
            if (cmbStatus.SelectedValue == null || !(cmbStatus.SelectedValue is ComputerStatus))
            {
                MessageBox.Show("ステータスを入れてください。");
                return;
            }

            parameters.Add("Name", txtComputer.Text);
            parameters.Add("Status", cmbStatus.SelectedValue);
            parameters.Add("PassThru", true);
            var command = new CommandInvoker("Set-Status", parameters);
            DataContext = command.Execute<Server>();
            _history.Write(command);

        }

    }
}
